
#property link      "http://www.carigold.com"
//+------------------------------------------------------------------+
//|                                                                  |
//| 2008 Added Speech. ( Speech.tpl ) Rev.2 ( itemsdepot@hotmail.com)|
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 Blue
//
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 5
#property indicator_width4 4

//---------------------------------
extern bool   FXSUpAlertBoxOn=False;
extern bool   FXSDownAlertBoxOn=False;
extern int    FXSAlertCandles=100;
extern int    FXSMaximumAlerts=2;
extern bool   FXSDrawGraphLines=True;
extern bool   FXSDrawStars=True;
extern bool   FXSPlayAudioAlertUp=True;
extern bool   FXSPlayAudioAlertDown=True;
extern string FXSUpWaveFileName="starsup.wav";
extern string FXSDownWaveFileName="starsdown.wav";
extern int    FXSTimeFrameSmall = 7;
extern int    FXSTimeFrameLarge = 14;
extern int    FXScountbars = 50;
extern int    FXSpower = 2;
extern double FXSAlarmDelay=7.0;
extern double FXSCounter=0.0;
extern int    FXSCandleAlertRange=4;
//-----------------------------------
double g_ibuf_76[];
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
int g_bars_108 = 0;
//----------------------------------------
int init() {
   if (FXSDrawGraphLines) SetIndexStyle(0,0,0,indicator_width1,indicator_color1); 
    else SetIndexStyle(0,12,0,indicator_width1,indicator_color1);
   SetIndexBuffer(0, g_ibuf_76);
   
   if (FXSDrawGraphLines) SetIndexStyle(1,0,0,indicator_width2,indicator_color2);
    else SetIndexStyle(1,12,0,indicator_width2,indicator_color2);
   SetIndexBuffer(1, g_ibuf_80);
   
   if (FXSDrawStars) SetIndexStyle(2,3,0,indicator_width3,indicator_color3); 
    else SetIndexStyle(2,12,0,indicator_width3,indicator_color3);                       
   SetIndexBuffer(2, g_ibuf_84);
   
   if (FXSDrawStars) SetIndexStyle(3,3,0,indicator_width4,indicator_color4); 
    else SetIndexStyle(3,12,0,indicator_width4,indicator_color4);
   SetIndexBuffer(3, g_ibuf_88);
   
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);
   SetIndexArrow(2, 170);
   SetIndexArrow(3, 170);

   FXSCounter=TimeCurrent();
   FXSAlarmDelay=14;
   return (0);
}
//-----------------------------------------
int deinit() {
   return (0);
}
//-----------------------------------------
int start() {
   int li_12;
   double ld_16;
   double ld_24;
   if (g_bars_108 == Bars) return (0);
   g_bars_108 = Bars;
   int li_unused_0 = IndicatorCounted();
   ArrayInitialize(g_ibuf_76, 0);
   ArrayInitialize(g_ibuf_80, 0);
   double FinishTime=TimeCurrent();
   
   //---------------------------------------------------------
   for (int li_4 = FXScountbars; li_4 > -1; li_4--) 
   {
      li_12 = FXSTimeFrameSmall + 1;
      ld_16 = 0;
      ld_24 = 0;
      for (int li_8 = li_4; li_8 < li_4 + FXSTimeFrameSmall; li_8++) {
         li_12--;
         ld_16 += Close[li_8] * MathPow(li_12, FXSpower);
      }
      li_12 = FXSTimeFrameSmall + 1;
      for (li_8 = li_4; li_8 < li_4 + FXSTimeFrameSmall; li_8++) {
         li_12--;
         ld_24 += MathPow(li_12, FXSpower);
      }
      g_ibuf_76[li_4] = ld_16 / ld_24;
   }
   
   
   
   //--------------------------------------------------------
   for (li_4 = FXScountbars; li_4 > -1; li_4--) {
      li_12 = FXSTimeFrameLarge + 1;
      ld_16 = 0;
      ld_24 = 0;
      for (li_8 = li_4; li_8 < li_4 + FXSTimeFrameLarge; li_8++) {
         li_12--;
         ld_16 += Close[li_8] * MathPow(li_12, FXSpower);
      }
      li_12 = FXSTimeFrameLarge + 1;
      for (li_8 = li_4; li_8 < li_4 + FXSTimeFrameLarge; li_8++) {
         li_12--;
         ld_24 += MathPow(li_12, FXSpower);
      }
      g_ibuf_80[li_4] = ld_16 / ld_24;
      if ((g_ibuf_80[li_4] - g_ibuf_76[li_4]) * (g_ibuf_80[li_4 + 1] - (g_ibuf_76[li_4 + 1])) < 0.0) 
      {
      
         //------------------------------------------
         if (g_ibuf_80[li_4] - g_ibuf_76[li_4] < 0.0) 
         {
           g_ibuf_84[li_4] = g_ibuf_76[li_4];
           
           //-----------------------
           FinishTime=TimeCurrent();     
           if (( FinishTime - FXSCounter > FXSAlarmDelay ) && li_4 < FXSCandleAlertRange )
           {
            FXSCounter=FinishTime;
            if ( FXSUpAlertBoxOn==True ) Alert("FX Star: Positive Cross at Candle: "+li_4+" Price: "+g_ibuf_76[li_4]);
            if ( FXSPlayAudioAlertUp==True ) PlaySound(FXSUpWaveFileName);
           }
           //-----------------------
         }
         
         
         //-----------------------------------------
         if (g_ibuf_80[li_4] - g_ibuf_76[li_4] > 0.0) 
         {
           g_ibuf_88[li_4] = g_ibuf_80[li_4];
           
           //-----------------------
           FinishTime=TimeCurrent();     
           if (( FinishTime - FXSCounter > FXSAlarmDelay ) && li_4 < FXSCandleAlertRange )
           {
            FXSCounter=FinishTime;
            if ( FXSUpAlertBoxOn==True ) Alert("FX Star: Positive Cross at Candle: "+li_4+" Price: "+g_ibuf_76[li_4]);
            if ( FXSPlayAudioAlertDown==True ) PlaySound(FXSDownWaveFileName);
           }
           //-----------------------
         }
      //---------
      }
   }
   double finishTime=GetTickCount();   //WindowRedraw();
   return (0);
}